var szBackScriptPort;
var lastCommand;


$(window).on('load', function () {
    $('#newWindowBtn').click(onNewWindowClickHandler);
    $('#newWindowBtnContent').html(chrome.i18n.getMessage('newWindowBtnStr'));
    $('#newTabBtn').click(onNewTabClickHandler);
    $('#newTabBtnContent').html(chrome.i18n.getMessage('newTabBtnStr'));
    $('#pinOnPageTabBtn').click(onPinOnPageClickHandler);
    $('#pinOnPageTabBtnContent').html(chrome.i18n.getMessage('PinOnPageBtnStr'));

    var pattern = '*://' + chrome.runtime.id + '/*';
    chrome.contentSettings.plugins.set({ primaryPattern: pattern, setting: 'allow' });
    szBackScriptPort = chrome.runtime.connect();
    szBackScriptPort.onMessage.addListener(onBackScriptResponse);
});

function onBackScriptResponse(response) {
    if (response && response.command && response.result == 'ok') {
        if (response.command.name === lastCommand.name
            && response.command.vid === lastCommand.vid
            && response.command.vtype === lastCommand.vtype) {

            window.close();
        }
    }
}

function onNewWindowClickHandler() {
    console.log("Create wnd", szBackScriptPort);
    if (szBackScriptPort) {
        console.log("Send message wnd");
        lastCommand = { name: 'open', vid: 0, vtype: 0 };
        szBackScriptPort.postMessage({ command: lastCommand });
    }
}
function onNewTabClickHandler() {
    console.log("Create tab");
    if (szBackScriptPort) {
        console.log("Send message tab");
        lastCommand = { name: 'open', vid: 0, vtype: 1 };
        szBackScriptPort.postMessage({ command: lastCommand });
    }
}
function onPinOnPageClickHandler() {
    console.log("Pin on page");
    if (szBackScriptPort) {
        console.log("Send message page");
        lastCommand = { name: 'open', vid: 0, vtype: 2 };
        szBackScriptPort.postMessage({ command: lastCommand });
    }
}