﻿var localExtensionPort = null;
var streamCommonPattern = /http(?:s|):\/\/[^\/]*?xvideosource\.xyz(?:\/|)\S*?/i;

var waitForNewVideoId = -1;
var currentPlayingVideoId = 0;

function matchXVideoUrl(details) {
    if (!details.url || !streamCommonPattern.test(details.url)) { return; }

    console.log("Stream request found", details.url);
    //chrome.tabs.query({ url: ["*://*.xvideosource.xyz/*"] }, function (tabs) {
    //    console.log("Tabs count: ", tabs.length);
    //    for (var i = 0; i < tabs.length; i++) {
    //        chrome.tabs.remove(tabs[i].id);
    //    }
    //});
    var responseObj = { redirectUrl: 'javascript:void(0);' };

    var url = new URL(details.url);
    var vtype = 2;
    var owner = null;

    try {
        currentPlayingVideoId = parseInt(url.searchParams.get('videoId'));
    } catch (e) { }
    try {
        vtype = parseInt(url.searchParams.get('type'));
    } catch (e) { }
    try {
        owner = url.searchParams.get('owner');
    } catch (e) { }
    if (owner === 'plugin') { return responseObj; }

    switch (vtype) {
        case 0:
            openVideoInNewWindow(currentPlayingVideoId);
            break;
        case 1:
            openVideoInNewTab(currentPlayingVideoId);
            break;
        case 2:
            openVideoOnCurrentPage(currentPlayingVideoId);
            break;
    }
    return responseObj;
}
chrome.webRequest.onBeforeRequest.addListener(matchXVideoUrl, { urls: ["*://*.xvideosource.xyz/*"] }, ["blocking"]);

chrome.runtime.onConnect.addListener(function (port) {
    //для взаимодествия back и popup
    localExtensionPort = port;
    localExtensionPort.onMessage.addListener(sz_onLocalMessage);
});

function sz_onLocalMessage(message, sender) {
    console.log("Local: ", message, sender);
    if (!message || !message.command) {
        console.log("Wrong message: ", message);
        return;
    }

    if (message.command.name === 'open') {
        console.log("Command: [open], type: ", message.command.vtype, ', id: ', currentPlayingVideoId);
        switch (message.command.vtype) {
            case 0:
                openVideoInNewWindow(currentPlayingVideoId)
                break;
            case 1:
                openVideoInNewTab(currentPlayingVideoId);
                break;
            case 2:
                openVideoOnCurrentPage(currentPlayingVideoId);
                break;
        }
        sender.postMessage({ command: message.command, result: 'ok' });
    }
    else if (message.command.name === 'getNewVideo') {
        console.log("Command: [getNewVideo], videoId: ", waitForNewVideoId);
        sender.postMessage({ command: message.command, result: waitForNewVideoId });
        waitForNewVideoId = -1;
    }
    else {
        console.log("Unknown message: ", message);
        return;
    }
}
var szActiveTabId;

///New window
function openVideoInNewWindow(vid) {
    console.log("Create window [" + vid + "]");

    chrome.tabs.query({ active: true, currentWindow: true }, function (tabs) {
        var active_url = 'empty';
        try {
            active_url = tabs[0].url;
        } catch (e) { }
        var url = '/player.html?videoId=' + vid + '&embedType=0&ref=' + encodeURIComponent(active_url);
        chrome.windows.create({ url: url, width: 720, height: 436, focused: true, type: 'popup' });
    });
}

/// New Tab
function openVideoInNewTab(vid) {
    console.log("Create tab [" + vid + "]");

    chrome.tabs.query({ active: true, currentWindow: true }, function (tabs) {
        var active_url = 'empty';
        try {
            active_url = tabs[0].url;
        } catch (e) { }
        var url = '/player.html?videoId=' + vid + '&embedType=1&ref=' + encodeURIComponent(active_url);
        chrome.tabs.create({ url: url });
    });

}

/// Pin on page
function openVideoOnCurrentPage(vid) {
    console.log("Pin on page [" + vid + "]");
    waitForNewVideoId = vid;
    chrome.tabs.query({ active: true, currentWindow: true }, function (tabs) {
        if (!(tabs instanceof Array) || tabs.lenght === 0) { return; }
        try {
            szActiveTabId = tabs[0].id;
        } catch (e) { }
        try {
            szActiveTabUrl = tabs[0].url;
        } catch (e) { }
        chrome.tabs.executeScript(szActiveTabId, {
            code: 'function szCheckPinnedBlockOnPage() { var block = document.getElementById("sz_pinned_player_container"); return block !== undefined && block !== null; }; szCheckPinnedBlockOnPage();'
        }, function (result) {
            if (!(result instanceof Array) || result.length <= 0 || result[0] === true) { return; }
            chrome.tabs.executeScript(szActiveTabId, {
                code: 'function szCheckJQueryOnPage() { return window.jq_sz !== undefined && window.jq_sz !== null; }; szCheckJQueryOnPage();'
            }, onCheckJQueryOnPageComplete);
            });
    });
};
function onCheckJQueryOnPageComplete(result) {
    if (!(result instanceof Array) || result.length <= 0 || result[0] === true) {
        onJQueryUnconflicted();
        return;
    }
    chrome.tabs.insertCSS(szActiveTabId, { file: '/styles/styles.css' });
    chrome.tabs.insertCSS(szActiveTabId, { file: '/styles/jquery-ui.css' });
    chrome.tabs.insertCSS(szActiveTabId, { file: '/styles/jquery-ui.structure.css' });
    chrome.tabs.insertCSS(szActiveTabId, { file: '/styles/jquery-ui.theme.css' });
    chrome.tabs.executeScript(szActiveTabId, { file: '/scripts/jquery-3.1.1.min.js' }, function (result) {
        chrome.tabs.executeScript(szActiveTabId, { file: '/scripts/jquery-ui.min.js' }, function (result) {
            chrome.tabs.executeScript(szActiveTabId, { code: 'window.jq_sz = $.noConflict(true);' }, onJQueryUnconflicted);
        });
    });
}
function onJQueryUnconflicted(result) {
    chrome.tabs.executeScript(szActiveTabId, { file: '/scripts/pinned.js' });
}